org.apache.sis.metadata.iso.lineage

## Class DefaultLineage

- Object
- - AbstractMetadata
  - - ModifiableMetadata
    - - ISOMetadata
      - - DefaultLineage

- All Implemented Interfaces:
    Serializable, Cloneable, Emptiable, LenientComparable, IdentifiedObject, Lineage

      public class DefaultLineage
      extends ISOMetadata
      implements Lineage

  Information about the events or source data used in constructing the data specified by the scope or lack of knowledge about lineage. The following properties are mandatory or conditional (i.e. mandatory under some circumstances) in a well-formed metadata according ISO 19115:
  `LI_Lineage` `├─statement……………………………………………………………` General explanation of the data producer's knowledge about the lineage of a dataset. `├─processStep………………………………………………………` Information about an event in the creation process for the data specified by the scope. `│ └─description……………………………………………` Description of the event, including related parameters or tolerances. `└─source……………………………………………………………………` Information about the source data used in creating the data specified by the scope. `├─description……………………………………………` Detailed description of the level of the source data. `└─scope……………………………………………………………` Type and / or extent of the source. `├─level…………………………………………………` Hierarchical level of the data specified by the scope. `└─levelDescription……………………` Detailed description about the level of the data specified by the scope. `├─attributeInstances……` Attribute instances to which the information applies. `├─attributes…………………………` Attributes to which the information applies. `├─dataset…………………………………` Dataset to which the information applies. `├─featureInstances…………` Feature instances to which the information applies. `├─features………………………………` Features to which the information applies. `└─other………………………………………` Class of information that does not fall into the other categories.
  At least one of statement, process steps and `sources` shall be provided.
  Limitations
  - Instances of this class are not synchronized for multi-threading. Synchronization, if needed, is caller's responsibility.
  - Serialized objects of this class are not guaranteed to be compatible with future Apache SIS releases. Serialization support is appropriate for short term storage or RMI between applications running the same version of Apache SIS. For long term storage, use `XML` instead.
  Since:
    0.3
  See Also:
    Serialized Form

  Defined in the `sis-metadata` module

- - ### Field Summary

    - ### Fields inherited from class ISOMetadata

      `identifiers`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DefaultLineage()` Constructs an initially empty lineage.
    `DefaultLineage(Lineage object)` Constructs a new instance initialized with the values from the specified metadata object.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static DefaultLineage` | `castOrCopy(Lineage object)` Returns a SIS metadata implementation with the values of the given arbitrary implementation.
    `Collection<Citation>` | `getAdditionalDocumentation()` Returns additional documentation.
    `Collection<ProcessStep>` | `getProcessSteps()` Returns the information about about events in the life of a resource specified by the scope.
    `Scope` | `getScope()` Returns the type of resource and / or extents to which the lineage information applies.
    `Collection<Source>` | `getSources()` Returns information about the source data used in creating the data specified by the scope.
    `InternationalString` | `getStatement()` Returns the general explanation of the data producer's knowledge about the lineage of a dataset.
    `void` | `setAdditionalDocumentation(Collection<? extends Citation> newValues)` Sets additional documentation.
    `void` | `setProcessSteps(Collection<? extends ProcessStep> newValues)` Sets information about events in the life of a resource specified by the scope.
    `void` | `setScope(Scope newValue)` Sets the type of resource and / or extents to which the lineage information applies.
    `void` | `setSources(Collection<? extends Source> newValues)` Sets information about the source data used in creating the data specified by the scope.
    `void` | `setStatement(InternationalString newValue)` Sets the general explanation of the data producers knowledge about the lineage of a dataset.

    - ### Methods inherited from class ISOMetadata

      `freeze, getIdentifierMap, getIdentifiers, getStandard`

    - ### Methods inherited from class ModifiableMetadata

      `checkWritePermission, clone, collectionType, copyCollection, copyList, copySet, isModifiable, nonNullCollection, nonNullList, nonNullSet, singleton, unmodifiable, writeCollection, writeList, writeSet`

    - ### Methods inherited from class AbstractMetadata

      `asMap, asTreeTable, equals, equals, getInterface, hashCode, isEmpty, prune, toString`

    - ### Methods inherited from class Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### DefaultLineage

          public DefaultLineage()

      Constructs an initially empty lineage.

    - #### DefaultLineage

          public DefaultLineage(Lineage object)

      Constructs a new instance initialized with the values from the specified metadata object. This is a shallow copy constructor, since the other metadata contained in the given object are not recursively copied.
      Parameters:
        `object` - the metadata to copy values from, or `null` if none.
      See Also:
        `castOrCopy(Lineage)`

  - ### Method Detail

    - #### castOrCopy

          public static DefaultLineage castOrCopy(Lineage object)

      Returns a SIS metadata implementation with the values of the given arbitrary implementation. This method performs the first applicable action in the following choices:
      - If the given object is `null`, then this method returns `null`.
      - Otherwise if the given object is already an instance of `DefaultLineage`, then it is returned unchanged.
      - Otherwise a new `DefaultLineage` instance is created using the copy constructor and returned. Note that this is a shallow copy operation, since the other metadata contained in the given object are not recursively copied.
      Parameters:
        `object` - the object to get as a SIS implementation, or `null` if none.
      Returns:
        a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

    - #### getStatement

          public InternationalString getStatement()

      Returns the general explanation of the data producer's knowledge about the lineage of a dataset. Can be provided only if scope level is `DATASET` or `SERIES`.
      Specified by:
        `getStatement` in interface `Lineage`
      Returns:
        explanation of the data producer's knowledge about the lineage, or `null`.

    - #### setStatement

          public void setStatement(InternationalString newValue)

      Sets the general explanation of the data producers knowledge about the lineage of a dataset.
      Parameters:
        `newValue` - the new statement.

    - #### getScope

          @UML(identifier="scope",
               obligation=OPTIONAL,
               specification=ISO_19115)
          public Scope getScope()

      Returns the type of resource and / or extents to which the lineage information applies.
      Returns:
        type of resource and / or extents to which the lineage information applies.
      Since:
        0.5

    - #### setScope

          public void setScope(Scope newValue)

      Sets the type of resource and / or extents to which the lineage information applies.
      Parameters:
        `newValue` - the new type of resource.
      Since:
        0.5

    - #### getAdditionalDocumentation

          @UML(identifier="additionalDocumentation",
               obligation=OPTIONAL,
               specification=ISO_19115)
          public Collection<Citation> getAdditionalDocumentation()

      Returns additional documentation.
      Returns:
        additional documentation.
      Since:
        0.5

    - #### setAdditionalDocumentation

          public void setAdditionalDocumentation(Collection<? extends Citation> newValues)

      Sets additional documentation.
      Parameters:
        `newValues` - Additional documentation.
      Since:
        0.5

    - #### getProcessSteps

          public Collection<ProcessStep> getProcessSteps()

      Returns the information about about events in the life of a resource specified by the scope.
      Specified by:
        `getProcessSteps` in interface `Lineage`
      Returns:
        information about events in the life of a resource.

    - #### setProcessSteps

          public void setProcessSteps(Collection<? extends ProcessStep> newValues)

      Sets information about events in the life of a resource specified by the scope.
      Parameters:
        `newValues` - the new process steps.

    - #### getSources

          public Collection<Source> getSources()

      Returns information about the source data used in creating the data specified by the scope.
      Specified by:
        `getSources` in interface `Lineage`
      Returns:
        information about the source data.

    - #### setSources

          public void setSources(Collection<? extends Source> newValues)

      Sets information about the source data used in creating the data specified by the scope.
      Parameters:
        `newValues` - the new sources.

Copyright © 2010–2017 The Apache Software Foundation. All rights reserved.